<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Service\DashboardFacilitiesService;
use FM\Traits\TResponse;

class DashboardFacilitiesController {
    use Tresponse;

    protected $DashboardFacilitiesService;

    public function __construct(DashboardFacilitiesService $DashboardFacilitiesService)
    {
        $this->DashboardFacilitiesService = $DashboardFacilitiesService;
    }

    public function getDadosLimpezaFinalizada(Request $request)
    {
        try {
            $data = $this->DashboardFacilitiesService->getDadosLimpezaFinalizada($request->getParameters());
            $this->sendResponse($data, 200);;
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    
    public function getDadosTarefaAtrasada(Request $request)
    {
        try {
            $data = $this->DashboardFacilitiesService->getDadosTarefaAtrasada($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDadosTarefaConcluida(Request $request)
    {
        try {
            $data = $this->DashboardFacilitiesService->getDadosTarefaConcluida($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDadosTarefaEmAndamento(Request $request)
    {
        try {
            $data = $this->DashboardFacilitiesService->getDadosTarefaEmAndamento($request->getParameters());
            $this->sendResponse($data, 200);;
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getNaoConformidadesPorLocal(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getNaoConformidadesPorLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getNaoConformidades(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getNaoConformidades($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTarefasPorCliente(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getTarefasPorCliente($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTarefasPorLocal(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getTarefasPorLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTarefasPorChecklist(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getTarefasPorChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVistoriasPendentes(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getVistoriasPendentes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVistoriasAtrasadas(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getVistoriasAtrasadas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVistoriasAvaliadas(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getVistoriasAvaliadas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVistoriasEmAndamento(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getVistoriasEmAndamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVistoriasCancelado(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getVistoriasCancelado($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVistoriasPorCliente(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getVistoriasPorCliente($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVistoriasPorChecklist(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getVistoriasPorChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVistoriasPorLocal(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getVistoriasPorLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAuditoriasAtrasadas(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getAuditoriasAtrasadas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAuditoriasEmAndamento(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getAuditoriasEmAndamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAuditoriasConcluidas(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getAuditoriasConcluidas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAuditoriasPendentes(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getAuditoriasPendentes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getAuditoriasPorLocal(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getAuditoriasPorLocal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

        
    public function getAuditoriasPorCliente(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getAuditoriasPorCliente($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAuditoriasPorModelo(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getAuditoriasPorModelo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDadosTarefaPendente(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getDadosTarefaPendente($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDadosTarefaCancelado(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getDadosTarefaCancelado($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDadosTarefaPendenteAprovacao(Request $request) 
    {
        try {
            $data = $this->DashboardFacilitiesService->getDadosTarefaPendenteAprovacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
