<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use FM\Traits\TResponse;
use FM\Service\RelatorioAuditoriaService;

class RelatorioAuditoriaController
{
    protected $RelatorioAuditoriaService;

    use TResponse;

    public function __construct(RelatorioAuditoriaService $RelatorioAuditoriaService)
    {
        $this->RelatorioAuditoriaService = $RelatorioAuditoriaService;
    }

    public function getCategoriasAuditoriaRelatorio(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->getCategoriasAuditoriaRelatorio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTopicosAuditoriaExecRelatorio(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->getTopicosAuditoriaExecRelatorio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosAuditoriaExecRelatorio(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->getCriteriosAuditoriaExecRelatorio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosAuditoria()
    {
        try {
            $data = $this->RelatorioAuditoriaService->getCriteriosAuditoria();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function alterarStatusCriterio(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->alterarStatusCriterio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function iniciarOuFinalizarAuditoria(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->iniciarOuFinalizarAuditoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarRascunhoAuditoria(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->salvarDadosObservacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function anexarImagemAuditoriaRelatorio(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->anexarImagemAuditoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getImagensTopicosAuditoria(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->getImagensTopicosAuditoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getImagensAuditoria(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->getImagensAuditoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirImagemAuditoria(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->excluirImagemAuditoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 

    public function verificarAlteracoes(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->verificarAlteracoes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function calcularNota(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->calcularNota($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function calcularPercentual(Request $request)
    {
        try {
            $data = $this->RelatorioAuditoriaService->calcularPercentual($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getParametrizacaoCriterios(Request $request)
    {
        try{
            $data = $this->RelatorioAuditoriaService->getParametrizacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getPercentualCategoria(Request $request)
    {
        try{
            $data = $this->RelatorioAuditoriaService->getPercentualCategoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getNotaPorCategoria(Request $request)
    {
        try{
            var_dump('oi');
            $data = $this->RelatorioAuditoriaService->getNotaPorCategoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
