<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Fm00004000TarefasFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    /* INTEGRAÇÃO COM SM */
    public function getContratos($parametros)
    {
        $sql = "SELECT FCM_RELACLOCALCONT.*,  FCT_CONTRATO.NRCONTRATOFCT
                    FROM FCM_RELACLOCALCONT
                        JOIN FCT_CONTRATO
                        ON FCT_CONTRATO.NRSEQCONTRATO = FCM_RELACLOCALCONT.NRSEQCONTRATO
                    WHERE ((FCM_RELACLOCALCONT.NRESTRUTURAM IN (:NRESTRUTURAM)) OR (FCM_RELACLOCALCONT.NRESTRUTURAM  IS NULL))";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    /* INTEGRAÇÃO COM SM */

    public function getTarefasGrid($parametros, $listaOperadores)
    {
        $sql = "SELECT
                    FCM_CHECKLISTAGEND.NRCHECKLISTAGEND,
                    FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, 
                    TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') AS DTHORAAGEND,
                    TO_CHAR(FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'DD/MM/YYYY HH24:MI') AS DTHRFINALAGEND,
                    TO_CHAR(FCM_CHECKLISTAGEND.DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS') AS DTINCLUSAO,
                    FCM_LOCALCLI.NRLOCALCLIENTE, 
                    FCM_LOCALCLI.NMLOCALCLIENTE, 
                    FCM_LOCALCLI.NRESTRUTURAM,
                    FCM_TIPOLOCALCLI.NRTIPOLOCALCLI,
                    FCM_TIPOLOCALCLI.NMTIPOLOCALCLI, 
                    FCT_CONTRATO.NRSEQCONTRATO,
                    FCM_CHECKLIST.NRCHECKLIST, 
                    FCM_CHECKLIST.NMCHECKLIST, 
                    FCM_CHECKLISTAGEND.IDTIPORECORRENCIA, 
                    FCM_CHECKLISTAGEND.IDSITUACAOAGEND,
                    FCM_CHECKLISTAGEND.CDOPERINCLUSAO,
                    OPERADOR.NMOPERADOR, 
                    FCM_CHECKLISTAGEND.CDOPERADOR, 
                    FCM_EQUIPE.NMEQUIPE,
                    FCM_EQUIPETAREFA.NREQUIPE,
                    FCM_EQUIPETAREFA.NREQUIPETAREFA,
                    FCM_LOCALCLI.CDCLIENTE, 
                    CLIENTE.NMRAZSOCCLIE,
                    CLIENTE.NMFANTCLIE, 
                    FCT_CONTRATO.NRCONTRATOFCT, 
                    FCM_CHECKLISTAGEND.IDATIVO, 
                    FCM_GERENCIAMENTOCHK.CDOPERADOR AS CDOPERADORPAI,
                    FCM_GERENCIAMENTOCHK.IDOBRIGAOBSERVACAO,
                    FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK,
                    FCM_CHECKLISTAGEND.IDTIPOMARCACAOTAREFA, 
                    FCM_CHECKLISTAGEND.NRPRIORIDADETAREFA, 
                    FCM_CHECKLISTAGEND.IDTAREFAEQUIPE,
                    FCM_CHECKLISTAGEND.NRESCOPOSTAREFA,
                    FCM_ESCOPOSTAREFA.NMESCOPOSTAREFA,
                    FCM_RELCHKAGENDMODPOP.NRMODELOPOP,
                    FCM_RELCHKAGENDMODPOP.DSOBSERVACAO,
                    FCM_RELCHKAGENDMODPOP.NRRELCHKAGENDMODPOP,
                    FCM_RELACHABOPER.NRHABILIDADE,
                    CASE
                        WHEN SYSDATE < FCM_CHECKLISTAGEND.DTHORAAGEND THEN ' '
                        WHEN FCM_CHECKLISTAGEND.IDSITUACAOAGEND = '2' THEN ' '  
                        WHEN FCM_CHECKLISTAGEND.IDSITUACAOAGEND = '3' THEN ' '
                        WHEN FCM_CHECKLISTAGEND.IDSITUACAOAGEND = '4' THEN ' '
                        WHEN TRUNC(SYSDATE) - TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) < 1 THEN GREATEST(FLOOR((SYSDATE - FCM_CHECKLISTAGEND.DTHORAAGEND) * 24), 0) || ' horas ' || GREATEST(FLOOR((SYSDATE - FCM_CHECKLISTAGEND.DTHORAAGEND) * 24 * 60) - (FLOOR((SYSDATE - FCM_CHECKLISTAGEND.DTHORAAGEND) * 24) * 60), 0) || ' minutos'
                        ELSE TRUNC(SYSDATE) - TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) || ' dias'
                    END AS ATRASO,
                    (SELECT RTRIM(XMLAGG(XMLELEMENT(E, FCM_RELCHKAGENDEPI.NREPI || ', ').EXTRACT('//text()')).GETCLOBVAL(), ', ') 
                        FROM FCM_RELCHKAGENDEPI
                        WHERE  FCM_RELCHKAGENDEPI.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                        AND FCM_RELCHKAGENDEPI.IDATIVO = 'S' ) AS NREPI,
                    (SELECT LISTAGG(NRCRITERIOTAREFACHK, ', ') WITHIN GROUP (ORDER BY NRCRITERIOTAREFACHK) 
                        FROM FCM_RELCRITERIOTAGTAREFACHK
                        WHERE   FCM_RELCRITERIOTAGTAREFACHK.NRTAREFACHK IN 
                            (SELECT NRTAREFACHK FROM FCM_TAREFACHK WHERE FCM_TAREFACHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST)  ) AS NRCRITERIOTAREFACHK,
                    (SELECT  LISTAGG(NRTAREFACHK, ', ') WITHIN GROUP (ORDER BY NRTAREFACHK) 
                            FROM  FCM_TAREFACHK 
                            WHERE  FCM_TAREFACHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST ) AS NRTAREFACHK,
                     (SELECT RTRIM(XMLAGG(XMLELEMENT(E, FCM_ATIVIDADECHK.NRATIVIDADECHK || ',').EXTRACT('//text()')).GETCLOBVAL(), ',')
                            FROM  FCM_ATIVIDADECHK
                            WHERE  FCM_CHECKLISTAGEND.NRCHECKLIST = FCM_ATIVIDADECHK.NRCHECKLIST ) AS NRATIVIDADECHK
                FROM 
                    FCM_CHECKLISTAGEND
                JOIN 
                    FCM_LOCALCLI ON FCM_CHECKLISTAGEND.NRLOCALCLIENTE = FCM_LOCALCLI.NRLOCALCLIENTE
                JOIN 
                    CLIENTE ON CLIENTE.CDCLIENTE = FCM_LOCALCLI.CDCLIENTE
                JOIN 
                    FCM_TIPOLOCALCLI ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                JOIN 
                    FCM_CHECKLIST ON FCM_CHECKLISTAGEND.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
                LEFT JOIN 
                    FCM_GERENCIAMENTOCHK ON FCM_GERENCIAMENTOCHK.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                LEFT JOIN 
                    OPERADOR ON FCM_CHECKLISTAGEND.CDOPERADOR = OPERADOR.CDOPERADOR
                LEFT JOIN 
                    FCT_CONTRATO ON FCT_CONTRATO.NRSEQCONTRATO = FCM_CHECKLISTAGEND.NRSEQCONTRATO
                LEFT JOIN 
                    FCM_EQUIPETAREFA ON FCM_EQUIPETAREFA.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                LEFT JOIN 
                    FCM_EQUIPE ON FCM_EQUIPE.NREQUIPE = FCM_EQUIPETAREFA.NREQUIPE
                LEFT JOIN 
                    FCM_RELCHKAGENDMODPOP ON FCM_CHECKLISTAGEND.NRCHECKLISTAGEND = FCM_RELCHKAGENDMODPOP.NRCHECKLISTAGEND
                LEFT JOIN 
                    FCM_ESCOPOSTAREFA ON FCM_CHECKLISTAGEND.NRESCOPOSTAREFA = FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA
                LEFT JOIN FCM_RELACHABOPER
                        ON FCM_RELACHABOPER.CDOPERADOR = OPERADOR.CDOPERADOR
                WHERE 
                    ((FCM_CHECKLISTAGEND.CDOPERADOR IN ($listaOperadores)) -- Tarefas criadas para operador específico
                        OR ((FCM_CHECKLISTAGEND.CDOPERADOR IS NULL) AND (FCM_CHECKLISTAGEND.IDTAREFAEQUIPE = 'N')) -- Tarefas sem operador
                        OR (FCM_EQUIPETAREFA.NREQUIPE IN 
                            (SELECT DISTINCT FCM_EQUIPE.NREQUIPE 
                            FROM FCM_EQUIPE
                            JOIN FCM_RELACEQUIPEOPER ON FCM_RELACEQUIPEOPER.NREQUIPE = FCM_EQUIPE.NREQUIPE
                            AND FCM_RELACEQUIPEOPER.NRORG = FCM_EQUIPE.NRORG
                            WHERE FCM_RELACEQUIPEOPER.CDOPERADOR IN ($listaOperadores))) -- Tarefas de equipe
                        OR FCM_CHECKLISTAGEND.CDOPERINCLUSAO = :CDOPERADOR) -- Operador de inclusão
                       AND FCM_CHECKLISTAGEND.IDATIVO = 'S'
                    ORDER BY FCM_CHECKLISTAGEND.DTHORAAGEND DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros, [], null, null, null, array('NREPI', 'NRATIVIDADECHK', 'NRTAREFACHK'));
    }


    public function getClientes()
    {
        $sql = "SELECT CDCLIENTE, NMRAZSOCCLIE, NMFANTCLIE
                  FROM CLIENTE
                  WHERE IDCLIEATIV = 'S'
                      AND IDATIVO = 'S' 
                      AND CDCLIENTE IN (SELECT CDCLIENTE 
                                          FROM FCM_LOCALCLI
                                      WHERE IDATIVO = 'S')";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getLocal($param, $cliente)
    {

        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE, NRESTRUTURAM, NRTIPOLOCALCLI
                FROM FCM_LOCALCLI
                WHERE IDATIVO = 'S'
                AND NRTIPOLOCALCLI IN ($param)
                AND FCM_LOCALCLI.CDCLIENTE = $cliente";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTipoLocalTarefa($cliente)
    {

        $sql = "SELECT DISTINCT FCM_TIPOLOCALCLI.NRTIPOLOCALCLI, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI
                FROM FCM_TIPOLOCALCLI
                JOIN FCM_LOCALCLI
                ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                WHERE FCM_TIPOLOCALCLI.IDTIPOLOCALCLI = '3'
                AND FCM_TIPOLOCALCLI.IDATIVO = 'S'
                AND FCM_LOCALCLI.CDCLIENTE IN ($cliente)
                ORDER BY NMTIPOLOCALCLI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getChecklistTarefa($param)
    {
        $sql = "SELECT NRCHECKLIST, 
                       NMCHECKLIST
                  FROM FCM_CHECKLIST
                  WHERE IDATIVO = 'S'
                    AND NRTIPOLOCALCLI IN ($param)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getItensChecklist($parametros)
    {
        $sql = "SELECT FCM_ATIVIDADECHK.NRATIVIDADECHK, FCM_ATIVIDADE.NMATIVIDADE 
                    FROM FCM_ATIVIDADE
                    JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                    JOIN FCM_CHECKLIST
                    ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
                    WHERE FCM_ATIVIDADE.IDATIVO = 'S' 
                    AND FCM_CHECKLIST.NRCHECKLIST = " . $parametros['NRCHECKLIST'];

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEscopo($listaAtividadeChk)
    {
        $sql = "SELECT DISTINCT FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA, FCM_ESCOPOSTAREFA.NMESCOPOSTAREFA
                    FROM FCM_ESCOPOSTAREFA
                    JOIN FCM_ITEMCHECKLISTESC
                    ON FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA = FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA
                    JOIN FCM_ITEMCHECKLIST
                    ON FCM_ITEMCHECKLIST.NRITEMCHECKLIST = FCM_ITEMCHECKLISTESC.NRITEMCHECKLIST
                    LEFT JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADECHK.NRATIVIDADE = FCM_ITEMCHECKLIST.NRATIVIDADE
                    WHERE FCM_ESCOPOSTAREFA.IDATIVO = 'S'
                    AND FCM_ATIVIDADECHK.NRATIVIDADECHK IN ($listaAtividadeChk)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTarefasSelect($listaEscopos, $listaAtividadeChk)
    {
        $sql = "SELECT DISTINCT FCM_TAREFACHK.NRTAREFACHK, FCM_TAREFA.NRTAREFA, 
                FCM_TAREFA.NMTAREFA, 
                FCM_TAREFA.NRPRIORIDADETAREFA, 
                FCM_PRIORIDADETAREFA.IDPRIORIDADE,
                LISTAGG(DISTINCT FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA, ', ') 
                    WITHIN GROUP (ORDER BY FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA) AS NRESCOPOSTAREFA
                FROM FCM_TAREFACHK 
                JOIN FCM_TAREFA 
                ON FCM_TAREFACHK.NRTAREFA = FCM_TAREFA.NRTAREFA
                JOIN FCM_ATIVIDADECHK 
                ON FCM_TAREFACHK.NRATIVIDADECHK = FCM_ATIVIDADECHK.NRATIVIDADECHK
                LEFT JOIN FCM_PRIORIDADETAREFA 
                ON FCM_PRIORIDADETAREFA.NRPRIORIDADETAREFA = FCM_TAREFA.NRPRIORIDADETAREFA
                JOIN FCM_ITEMCHECKLIST
                ON FCM_TAREFA.NRTAREFA = FCM_ITEMCHECKLIST.NRTAREFA
                JOIN FCM_ITEMCHECKLISTESC
                ON FCM_ITEMCHECKLISTESC.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST
                WHERE FCM_TAREFA.IDATIVO = 'S'
                AND FCM_ATIVIDADECHK.NRATIVIDADECHK IN ($listaAtividadeChk)
                AND FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA IN ($listaEscopos)
                GROUP BY FCM_TAREFACHK.NRTAREFACHK,
                        FCM_TAREFA.NRTAREFA, 
                        FCM_TAREFA.NMTAREFA, 
                        FCM_TAREFA.NRPRIORIDADETAREFA, 
                        FCM_PRIORIDADETAREFA.IDPRIORIDADE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getCriterios($parametros, $listaEscopos, $listaAtividadeChk, $listaTarefaChk)
    {
        $sql = "SELECT FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFACHK,FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA, FCM_CRITERIOTAREFA.DSCRITERIOTAREFA, FCM_CRITERIOTAREFACHK.NRTAREFACHK, 
                    FCM_CHECKLIST.NRCHECKLIST, FCM_ATIVIDADECHK.NRATIVIDADECHK, FCM_TAREFA.NMTAREFA,
                    (SELECT RTRIM(XMLAGG(XMLELEMENT(E, FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA || ',').EXTRACT('//text()')).GETCLOBVAL(), ',')
                                FROM FCM_ESCOPOSTAREFA
                                JOIN FCM_ITEMCHECKLISTESC
                                    ON FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA = FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA
                                    JOIN FCM_ITEMCHECKLIST
                                    ON FCM_ITEMCHECKLISTESC.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST 
                                    AND FCM_ATIVIDADECHK.NRATIVIDADE = FCM_ITEMCHECKLIST.NRATIVIDADE
                                    AND FCM_TAREFA.NRTAREFA = FCM_ITEMCHECKLIST.NRTAREFA
                            WHERE FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA IN ($listaEscopos)
                            AND FCM_ATIVIDADECHK.NRATIVIDADECHK IN ($listaAtividadeChk)
                            AND FCM_ESCOPOSTAREFA.IDATIVO = 'S') AS NRESCOPOSTAREFA
                        FROM FCM_CRITERIOTAREFACHK 
                        JOIN FCM_CRITERIOTAREFA 
                            ON FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA = FCM_CRITERIOTAREFA.NRCRITERIOTAREFA
                        JOIN FCM_TAREFACHK 
                            ON FCM_CRITERIOTAREFACHK.NRTAREFACHK = FCM_TAREFACHK.NRTAREFACHK
                        JOIN FCM_ATIVIDADECHK
                            ON FCM_TAREFACHK.NRATIVIDADECHK = FCM_ATIVIDADECHK.NRATIVIDADECHK
                        JOIN FCM_CHECKLIST
                            ON FCM_CHECKLIST.NRCHECKLIST = FCM_ATIVIDADECHK.NRCHECKLIST
                        JOIN FCM_TAREFA
                            ON FCM_TAREFACHK.NRTAREFA = FCM_TAREFA.NRTAREFA
                        WHERE FCM_CRITERIOTAREFA.IDATIVO = 'S'
                        AND FCM_CRITERIOTAREFACHK.NRTAREFACHK IN ($listaTarefaChk)
                        AND FCM_CHECKLIST.NRCHECKLIST  = :NRCHECKLIST
                        AND FCM_ATIVIDADECHK.NRATIVIDADECHK IN ($listaAtividadeChk)";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros, [], null, null, null, array('NRESCOPOSTAREFA'));
    }

    public function getFuncionario($locais)
    {
        $sql = "SELECT DISTINCT OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR
                    FROM OPERADOR
                    JOIN FCM_FUNCIONARIOSHIERARQ
                    ON FCM_FUNCIONARIOSHIERARQ.CDOPERADOR = OPERADOR.CDOPERADOR
                    JOIN FCM_HIERARQUIAFUNC
                    ON FCM_HIERARQUIAFUNC.NRHIERARQUIAFUNC = FCM_FUNCIONARIOSHIERARQ.NRHIERARQUIAFUNC
                LEFT JOIN FCM_RELACHABOPER 
                    ON FCM_RELACHABOPER.CDOPERADOR = OPERADOR.CDOPERADOR
                LEFT JOIN  FCM_RELACHABATIV
                    ON  FCM_RELACHABATIV.NRHABILIDADE = FCM_RELACHABOPER.NRHABILIDADE
                    LEFT JOIN FCM_TAREFACHK
                    ON FCM_TAREFACHK.NRTAREFA = FCM_RELACHABATIV.NRTAREFA
                WHERE FCM_HIERARQUIAFUNC.NRLOCALCLIENTE IN (SELECT NRLOCALCLIENTE
                                                                FROM FCM_LOCALCLI
                                                            START WITH NRLOCALCLIENTE IN ($locais)
                                                            CONNECT BY PRIOR NRLOCALCLIENTEPAI = NRLOCALCLIENTE)";


        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
   
    public function getEpis()
    {
        $sql = "SELECT NREPI, NMEPI, IDATIVO, NRORG 
                        FROM FCM_EPI"; 
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEquipeTarefa($locais) 
    {
        $sql = "SELECT DISTINCT FCM_EQUIPE.NREQUIPE, FCM_EQUIPE.NMEQUIPE 
                    FROM FCM_EQUIPE
                    JOIN FCM_RELACEQUIPEOPER 
                    ON FCM_RELACEQUIPEOPER.NREQUIPE = FCM_EQUIPE.NREQUIPE
                    JOIN FCM_FUNCIONARIOSHIERARQ
                    ON FCM_FUNCIONARIOSHIERARQ.CDOPERADOR = FCM_RELACEQUIPEOPER.CDOPERADOR
                    JOIN FCM_HIERARQUIAFUNC
                    ON FCM_HIERARQUIAFUNC.NRHIERARQUIAFUNC = FCM_FUNCIONARIOSHIERARQ.NRHIERARQUIAFUNC
                    WHERE FCM_HIERARQUIAFUNC.NRLOCALCLIENTE IN (SELECT NRLOCALCLIENTE
                                                                FROM FCM_LOCALCLI
                                                                START WITH NRLOCALCLIENTE IN ($locais)
                                                                CONNECT BY PRIOR NRLOCALCLIENTEPAI = NRLOCALCLIENTE)
                    AND FCM_EQUIPE.IDATIVO = 'S'";  // Condição adicionada para trazer apenas as equipes ativas
    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getModeloPop()
    {
        $sql = "SELECT NRMODELOPOP, NMMODELOPOP, IDATIVO, NRORG 
                    FROM FCM_MODELOPOP"; 

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTarefasPorOperadorEdicao($parametros)
    {
        $sql = "SELECT TO_CHAR(DTHORAAGEND,'MM/DD/YYYY HH24:MI') AS DATAINICIAL, 
                    TO_CHAR(DTHRFINALAGEND, 'MM/DD/YYYY HH24:MI') AS DATAFINAL
                    FROM FCM_CHECKLISTAGEND
                    WHERE IDATIVO = 'S'
                    AND CDOPERADOR = :CDOPERADOR
                    AND TRUNC(DTHORAAGEND) = TO_DATE(:DTHORAAGEND, 'DD/MM/YYYY')
                    AND IDSITUACAOAGEND NOT IN ('3','4')
                    AND NRCHECKLISTAGEND <> :NRCHECKLISTAGEND";
        
        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }
    public function updateTarefa($params)
    {
        $sql = "UPDATE FCM_CHECKLISTAGEND 
                        SET 
                            NMCHECKLISTAGEND = :NMCHECKLISTAGEND,
                            CDOPERADOR = :CDOPERADOR,
                            DTHORAAGEND = :DTHORAAGEND,
                            DTHRFINALAGEND = :DTHRFINALAGEND,
                            IDOBRIGAOBSERVACAO = :IDOBRIGAOBSERVACAO,
                            IDTIPOMARCACAOTAREFA = :IDTIPOMARCACAOTAREFA,
                            NRPRIORIDADETAREFA = :NRPRIORIDADETAREFA,
                            IDTAREFAEQUIPE = :IDTAREFAEQUIPE,
                            CDOPERULTATU = :CDOPERULTATU,
                            DTULTATU = SYSDATE
                        WHERE 
                            NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        $this->connection->executeStatement($sql, $params);
    }

    public function getSupervisorTarefa($locais, $operadores)
    {
        $sql = "SELECT DISTINCT OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR
                        FROM OPERADOR
                        JOIN FCM_FUNCIONARIOSHIERARQ
                        ON FCM_FUNCIONARIOSHIERARQ.CDOPERADOR = OPERADOR.CDOPERADOR
                        JOIN FCM_HIERARQUIAFUNC
                        ON FCM_HIERARQUIAFUNC.NRHIERARQUIAFUNC = FCM_FUNCIONARIOSHIERARQ.NRHIERARQUIAFUNC
                    WHERE FCM_FUNCIONARIOSHIERARQ.CDOPERADOR IN (SELECT CDOPERADORPAI
                                                                    FROM FCM_FUNCIONARIOSHIERARQ
                                                                    WHERE CDOPERADORPAI IS NOT NULL
                                                                    START WITH CDOPERADOR IN ($operadores)
                                                                    CONNECT BY PRIOR CDOPERADORPAI = CDOPERADOR)
                        AND FCM_HIERARQUIAFUNC.NRLOCALCLIENTE IN (SELECT NRLOCALCLIENTE
                                                FROM FCM_LOCALCLI
                                                START WITH NRLOCALCLIENTE IN ($locais)
                                                CONNECT BY PRIOR NRLOCALCLIENTEPAI = NRLOCALCLIENTE)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function validaCriterio($parametros)
    {

        $sql = "SELECT COUNT(*) AS VALIDA
                  FROM FCM_CRITERIOTAREFACHK 
                 WHERE NRTAREFACHK = :NRTAREFACHK
                   AND NRCRITERIOTAREFA = :NRCRITERIOTAREFA";


        $resultado = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $resultado[0]['VALIDA'];
    }

    public function insertChecklistagend($params)
    {

        $sql = "INSERT INTO FCM_CHECKLISTAGEND (
                                NRCHECKLISTAGEND, NMCHECKLISTAGEND, NRLOCALCLIENTE, NRCHECKLIST, CDOPERADOR, IDSITUACAOAGEND, DTHORAAGEND,  IDATIVO, DTINCLUSAO, 
                                DTHRFINALAGEND, CDOPERINCLUSAO, IDOBRIGAOBSERVACAO, NRSEQCONTRATO, IDTIPOMARCACAOTAREFA, IDTIPORECORRENCIA, NRPRIORIDADETAREFA, 
                                IDTAREFAEQUIPE, NRESCOPOSTAREFA)
                     VALUES (
                            :NRCHECKLISTAGEND, :NMCHECKLISTAGEND, :NRLOCALCLIENTE, :NRCHECKLIST, :CDOPERADOR, :IDSITUACAOAGEND, :DTHORAAGEND, 'S', SYSDATE, 
                            :DTHRFINALAGEND, :CDOPERINCLUSAO, :IDOBRIGAOBSERVACAO, :NRSEQCONTRATO, :IDTIPOMARCACAOTAREFA, :IDTIPORECORRENCIA, :NRPRIORIDADETAREFA,
                            :IDTAREFAEQUIPE, :NRESCOPOSTAREFA)";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertTarefa($params)
    {
        $sql = "INSERT INTO FCM_TAREFAAGEND (
                                NRTAREFAAGEND, NRCHECKLISTAGEND, NRTAREFACHK, 
                                CDOPERADOR, DTHORATAREFAAGEND, DSOBSTAREFAAGEND, 
                                IDREALIZADO,  IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO, NRTAREFARECORRENTE
            )
            VALUES (
                    :NRTAREFAAGEND, :NRCHECKLISTAGEND, :NRTAREFACHK, 
                    :CDOPERADOR, :DTHORAAGEND, :DSOBSTAREFAAGEND, 
                    'N',  'S', SYSDATE, :CDOPERINCLUSAO, :NRTAREFARECORRENTE)";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertCriterio($params)
    {

        $sql = "INSERT INTO FCM_CRITERIOTARAGEND (
                                NRCRITERIOTARAGEND, NMCRITERIOTARAGEND, NRTAREFAAGEND, 
                                NRCRITERIOTAREFACHK, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO
            )
                    VALUES (
                        :NRCRITERIOTARAGEND,:NMCRITERIOTARAGEND, :NRTAREFAAGEND, 
                        :NRCRITERIOTAREFACHK, 'S', SYSDATE, 
                        :OPERADOR
                    )";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertChk($params)
    {
        $sql = "INSERT INTO FCM_GERENCIAMENTOCHK (
                                NRGERENCIAMENTOCHK, NMGERENCIAMENTOCHK, NRLOCALCLIENTE, 
                                NRCHECKLIST, CDOPERADOR, IDSITUACAOGERCHK, 
                                DTHORAAGEND, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO, NRCHECKLISTAGEND,DTHRFINALAGEND, IDOBRIGAOBSERVACAO, NRSEQCONTRATO)
                VALUES (
                    :NRGERENCIAMENTOCHK, :NMGERENCIAMENTOCHK, :NRLOCALCLIENTE, 
                    :NRCHECKLIST, :CDOPERADOR, '1',  
                    :DTHORAAGEND, 'S', SYSDATE, 
                    :OPERADOR, :NRCHECKLISTAGEND,TO_DATE(:DTHRFINALAGEND), :IDOBRIGAOBSERVACAO, :NRSEQCONTRATO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertChkHistorico($parametros)
    {
        $sql = "INSERT INTO FCM_GERCHKHISTORICO (
                    NRGERCHKHISTORICO,      NRGERENCIAMENTOCHK, NMGERENCIAMENTOCHK, DSGERENCIAMENTOCHK,
                    DTHISTGERENCIAMENTOCHK, IDTIPOHISTORICO,    IDATIVO,            NRORG,
                    DTINCLUSAO,             CDOPERINCLUSAO,     NRORGINCLUSAO,      DTULTATU,
                    CDOPERULTATU,           NRORGULTATU
                )
                VALUES (
                    :NRGERCHKHISTORICO,     :NRGERENCIAMENTOCHK, :NMGERENCIAMENTOCHK, :DSGERENCIAMENTOCHK,
                    SYSDATE,                :IDTIPOHISTORICO,    'S',                 :NRORG,
                    SYSDATE,                :CDOPERINCLUSAO,     :NRORGINCLUSAO,      SYSDATE,
                    :CDOPERULTATU,          :NRORGULTATU
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizaHistoricoTarefa($parametros)
    {
        $sql = "INSERT INTO FCM_CHKAGENDHISTORICO (
                    NRCHKAGENDHISTORICO,    NRCHECKLISTAGEND,   NMCHECKLISTAGEND,   DSCHKAGENDHISTORICO,
                    DTCHKAGENDHISTORICO,    IDTIPOHISTORICO,    IDATIVO,            NRORG,
                    DTINCLUSAO,             CDOPERINCLUSAO,     NRORGINCLUSAO,      DTULTATU,
                    CDOPERULTATU,           NRORGULTATU
                )
                VALUES (
                    :NRCHKAGENDHISTORICO,   :NRCHECKLISTAGEND,  :NMCHECKLISTAGEND,  :DSCHKAGENDHISTORICO,
                    SYSDATE,                :IDTIPOHISTORICO,   'S',                :NRORG,
                    SYSDATE,                :CDOPERINCLUSAO,    :NRORGINCLUSAO,     SYSDATE,
                    :CDOPERULTATU,          :NRORGULTATU
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function insertChkTarefa($params)
    {
        $sql = "INSERT INTO FCM_TAREFAGERCHK (
            NRTAREFAGERCHK, NRGERENCIAMENTOCHK, NRTAREFACHK, 
            CDOPERADOR, DTHORATAREFAGERCHK, DSOBSTAREFAGERCHK, 
            IDATIVO, DTINCLUSAO,  CDOPERINCLUSAO
            )
            VALUES (
                :NRTAREFAGERCHK, :NRGERENCIAMENTOCHK, :NRTAREFACHK, 
                :CDOPERADOR, :DTHORATAREFAGERCHK, :DSOBSTAREFAGERCHK, 
                'S', SYSDATE, :OPERADOR
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertChkCriterio($params)
    {
        $sql = "INSERT INTO FCM_CRITERIOTARGERCHK (
                                NRCRITERIOTARGERCHK, NMCRITERIOTARGERCHK, NRTAREFAGERCHK, 
                                NRCRITERIOTAREFACHK, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO
                )
                     VALUES (
                        :NRCRITERIOTARGERCHK, :NMCRITERIOTARGERCHK,
                        :NRTAREFAGERCHK, :NRCRITERIOTAREFACHK,  'S', 
                        SYSDATE, :OPERADOR
                    )";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertEpis($params)
    {
        $sql = "INSERT INTO FCM_RELCHKAGENDEPI (NRRELCHKAGENDEPI, NREPI, NRCHECKLISTAGEND, IDATIVO, DTINCLUSAO, CDOPERINCLUSAO, DTULTATU, NRORG)
                VALUES (:NRRELCHKAGENDEPI, :NREPI, :NRCHECKLISTAGEND, 'S', SYSDATE, :CDOPERINCLUSAO,  SYSDATE, :NRORG)";
         $this->connection->executeStatement($sql, $params);
    }

    public function insertModeloPop($params)
    {
        $sql = "INSERT INTO FCM_RELCHKAGENDMODPOP (
                    NRRELCHKAGENDMODPOP, NRMODELOPOP, NRCHECKLISTAGEND, DSOBSERVACAO, 
                    IDATIVO, NRORG, DTINCLUSAO, 
                    CDOPERINCLUSAO, NRORGINCLUSAO, DTULTATU, CDOPERULTATU, NRORGULTATU
                )
                VALUES (
                    :NRRELCHKAGENDMODPOP, :NRMODELOPOP, :NRCHECKLISTAGEND, :DSOBSERVACAO, 
                    'S', :NRORG, SYSDATE, 
                    :CDOPERINCLUSAO, :NRORGINCLUSAO, SYSDATE, :CDOPERULTATU, :NRORGULTATU
                )";
                $this->connection->executeStatement($sql, $params);
    }

    public function updateModeloPop($params)
    {
        $sql = "UPDATE  FCM_RELCHKAGENDMODPOP
                SET NRMODELOPOP = :NRMODELOPOP,
                        DSOBSERVACAO = :DSOBSERVACAO,
                        DTULTATU = SYSDATE, 
                        CDOPERULTATU = :CDOPERULTATU,
                        NRORGULTATU = :NRORGULTATU
                WHERE NRRELCHKAGENDMODPOP = :NRRELCHKAGENDMODPOP";
            
        $this->connection->executeStatement($sql, $params);
    }
    public function deletarTarefas($param)
    {
        $sql = "UPDATE FCM_CHECKLISTAGEND
                 SET IDATIVO  = 'N'
                 WHERE NRCHECKLISTAGEND IN (" . $param . ")";

        $this->connection->executeStatement($sql);

        $sql1 = "UPDATE FCM_GERENCIAMENTOCHK
                 SET IDATIVO  = 'N'
                 WHERE NRCHECKLISTAGEND IN (" . $param . ")";

        $this->connection->executeStatement($sql1);

    }

    public function getEpisRelacionados($parametros)
    {
        $sql = "SELECT NRRELCHKAGENDEPI, NREPI FROM FCM_RELCHKAGENDEPI
                    WHERE NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function deletarEpis($nrchecklistagend = null, $nrrelchkagendepi = null)
    {
        // Verifica se os dois parâmetros foram passados ao mesmo tempo, o que não é permitido
        if (!empty($nrchecklistagend) && !empty($nrrelchkagendepi)) {
            throw new \InvalidArgumentException('Use apenas um dos parâmetros: NRCHECKLISTAGEND ou NRRELCHKAGENDEPI.');
        }
    
        // Constrói a query com base em qual parâmetro foi passado
        if (!empty($nrchecklistagend)) {
            $sql = "DELETE FROM FCM_RELCHKAGENDEPI WHERE NRCHECKLISTAGEND IN ($nrchecklistagend)";
        } elseif (!empty($nrrelchkagendepi)) {
            $sql = "DELETE FROM FCM_RELCHKAGENDEPI WHERE NRRELCHKAGENDEPI IN ($nrrelchkagendepi)";
        } else {
            // Se ambos forem null ou vazios, lança uma exceção
            throw new \InvalidArgumentException('Nenhum critério de exclusão foi fornecido.');
        }
    
        // Executa a query
        $this->connection->executeStatement($sql);
    }
    

    public function deletarModpop($parametros)
    {
        $sql1 = "DELETE
                FROM FCM_RELCHKAGENDMODPOP
                WHERE NRCHECKLISTAGEND IN (" . $parametros . ")";

        $this->connection->executeStatement($sql1);
    }


    public function getTarefasSelectAll()
    {
        $sql = "SELECT A.NRTAREFACHK, C.NMTAREFA
                  FROM FCM_TAREFACHK A
                  JOIN FCM_ATIVIDADECHK B
                  ON A.NRATIVIDADECHK = B.NRATIVIDADECHK
                  JOIN FCM_TAREFA C
                  ON A.NRTAREFA = C.NRTAREFA
                  WHERE C.IDATIVO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function populaEscopo($param)
    {
        $sql = "SELECT DISTINCT E.NMESCOPOSTAREFA
                           FROM FCM_CHECKLISTAGEND CA
                     INNER JOIN FCM_GERENCIAMENTOCHK GC ON CA.NRCHECKLIST = GC.NRCHECKLIST
                     INNER JOIN FCM_ESCOPOSTAREFACHK EC ON GC.NRCHECKLIST = EC.NRCHECKLIST
                     INNER JOIN FCM_ESCOPOSTAREFA E ON EC.NRESCOPOSTAREFA = E.NRESCOPOSTAREFA
                          WHERE CA.NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $param);
    }

    public function getAtividade($param)
    {
        $sql = "SELECT T.NMTAREFA
                  FROM FCM_CHECKLISTAGEND CA
            INNER JOIN FCM_GERENCIAMENTOCHK GC ON CA.NRCHECKLIST = GC.NRCHECKLIST
            INNER JOIN FCM_ATIVIDADECHK AC ON GC.NRCHECKLIST = AC.NRCHECKLIST
            INNER JOIN FCM_ATIVIDADE A ON AC.NRATIVIDADE = A.NRATIVIDADE
            INNER JOIN FCM_TAREFA T ON A.NRATIVIDADE = T.NRATIVIDADE
                 WHERE CA.NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $param);
    }

    public function populaCriterios($nrTarefachk)
    {
        $sql = " SELECT NRCRITERIOTAREFACHK 
                    FROM FCM_CRITERIOTAREFACHK
                    WHERE NRTAREFACHK = $nrTarefachk";


        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getNrtarefachk($parametros)
    {
        $sql = "SELECT NRTAREFACHK 
                FROM FCM_TAREFACHK
                    WHERE NRCHECKLIST = :NRCHECKLIST 
                    AND NRATIVIDADECHK = :NRATIVIDADECHK";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getCriarVistoria($param)
    {
        $sql = "SELECT CDOPERADOR
                FROM FCM_GERENCIAMENTOCHK
                WHERE NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $param);
    }

    public function inserirEquipe($parametros)
    {
        $sql = "INSERT INTO FCM_EQUIPETAREFA(NREQUIPETAREFA, NREQUIPE, NRCHECKLISTAGEND, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                VALUES (:NREQUIPETAREFA, :NREQUIPE, :NRCHECKLISTAGEND, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateEquipe($parametros)
    {
        $sql = "UPDATE  FCM_EQUIPETAREFA 
            SET NREQUIPE = :NREQUIPE,
                    NRCHECKLISTAGEND = :NRCHECKLISTAGEND,
                    DTULTATU = SYSDATE, 
                    CDOPERULTATU = :CDOPERULTATU,
                    NRORGULTATU = :NRORGULTATU
            WHERE NREQUIPETAREFA = :NREQUIPETAREFA";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateResponsavelVistoria($param)
    {
        $sql = "UPDATE  FCM_GERENCIAMENTOCHK
                SET CDOPERADOR = :CDOPERADOR,
                        DTULTATU = SYSDATE, 
                        CDOPERULTATU = :CDOPERULTATU,
                        NRORGULTATU = :NRORGULTATU
                WHERE NRCHECKLISTAGEND = :NRCHECKLISTAGEND";
        
        $this->connection->executeStatement($sql, $param);
    }

    public function deleteRelacEquipeTarefa($parametros)
    {
        $sql = "DELETE FROM FCM_EQUIPETAREFA
                    WHERE NRCHECKLISTAGEND = :NRCHECKLISTAGEND";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function buscarOperadoresEquipe($parametros)
    {
        $sql = "SELECT CDOPERADOR   
                FROM FCM_RELACEQUIPEOPER
                WHERE NREQUIPE = :NREQUIPE";
        
        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getHistoricoTarefa($parametros)
    {
        $sql = "SELECT HIST.NRCHKAGENDHISTORICO, HIST.NRCHECKLISTAGEND, HIST.NMCHECKLISTAGEND, HIST.DSCHKAGENDHISTORICO, 
                TO_CHAR(HIST.DTCHKAGENDHISTORICO, 'DD/MM/YYYY HH24:MI') AS DTCHKAGENDHISTORICO, HIST.IDTIPOHISTORICO, HIST.DTINCLUSAO,
                TO_CHAR(HIST.DTULTATU, 'DD/MM/YYYY HH24:MI') AS DTULTATU, HIST.CDOPERULTATU, OPER.NMOPERADOR AS NMOPERULTATU
                FROM FCM_CHKAGENDHISTORICO HIST
                JOIN OPERADOR OPER ON OPER.CDOPERADOR = HIST.CDOPERULTATU
                WHERE HIST.NRCHECKLISTAGEND = :NRCHECKLISTAGEND
                ORDER BY HIST.DTCHKAGENDHISTORICO DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }
}
